<?php

namespace Plugin\Examples\Example\Foo;

use NoccyLabs\Plugin\PluginAwareInterface;
use NoccyLabs\Plugin\PluginInstance;

class FooExamplePlugin implements PluginAwareInterface
{
    protected $plugin;

    public function setPluginInstance(PluginInstance $plugin)
    {
        $this->plugin = $plugin;
    }

    public function onLoad()
    {
        echo "[example.config] PluginClass::onLoad()\n";
        if ($this->plugin->hasExtension("config")) {
            $config = $this->plugin->getConfiguration();
            $config->addIntProp("answer",42);
            $config->addMixedProp("xyzzzy",[true,false,null]);
        }
    }

    public function onUnload()
    {
        echo "[example.config] PluginClass::onUnload()\n";
    }
}

return new FooExamplePlugin();
