<?php

namespace NoccyLabs\Plugin\Extension;

use NoccyLabs\Plugin\PluginManager;
use NoccyLabs\Plugin\PluginInstance;

// --8<-- ResourceExtension.php

/**
 * Enables a plugin to use resources.
 *
 *
 *
 */
class ResourceExtension extends AbstractExtension
{

    public function getDefaultName()
    {
        return "resource";
    }

    public function onRegister()
    {
        $this->plugin->extend("getResources", [ $this, "getResources" ]);
    }

    public function getResources()
    {
        $res = $this->plugin->getPath("resources.json");
        if (!$res) {
            // no resource manifests
            return false;
        }

        return ResourceBundle::createFromManifest($this->plugin,$res);
    }

}

// --8<-- ResourceBundle.php

class ResourceBundle
{
    public static function createFromManifest($plugin,$path)
    {

    }
}

