<?php

namespace NoccyLabs\Plugin\Loader;

class DirectoryLoader extends AbstractLoader
{

    public static function test($path)
    {
        return (file_exists($path."/plugin.json"));
    }

    public function createAutoloader($type,$ns,$path)
    {
        $ns = rtrim($ns,"\\")."\\";
        $path = rtrim($path,"/")."/";
        $loader = function ($class) use ($type, $ns, $path) {
            if (strncmp($ns, $class, strlen($ns)) !== 0)
                return;
            if ($type == 'psr-4') {
                $classRel = substr($class, strlen($ns));
                $classPath = str_replace("\\","/",$classRel).".php";
            } elseif ($type == 'psr-0') {
                $classPath = str_replace("\\","/",$class).".php";
            }
            $srcPath = $this->getPath($path . "/" . $classPath, true);
            if ($srcPath)
                require_once $srcPath;
        };
        return $loader;
    }

    public function getPath($path, $test=false)
    {
        $ret = $this->root."/".$path;
        if (!$test) return $ret;
        return file_exists($ret)?$ret:false;
    }
}

