<?php

namespace NoccyLabs\Plugin\Loader;

class LoaderFactory
{
    private function __construct() {}
    private function __clone() {}

    protected static $loaders;

    public static function addDefaultLoaderPrototypes()
    {    
        self::$loaders = [
            new DirectoryLoader(),
            new ArchiveLoader(),
            new PharLoader()
        ];
    }

    public static function addLoaderPrototype(AbstractLoader $loader)
    {
        self::$loaders[] = $loaderClass;
    }

    public static function createLoader($path)
    {
        foreach (self::$loaders as $loader) {
            if ($loader::test($path)) {
                return $loader::create($path);
            }
        }
        return false;
    }
}

if (!defined("PLUGIN_NO_DEFAULT_LOADERS")) {
    LoaderFactory::addDefaultLoaderPrototypes();
}

